<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <audio id="audio"></audio>
    <button id="play-btn">播放</button>
    <script>
        var context = new(window.AudioContext || window.webkitAudioContext)();
        var source = null;
        var audioBuffer = null;
        function stopSound() {
            if (source) {
                source.noteOff(0); //立即停止
            }
        }
        function playSound() {
            source = context.createBufferSource();
            source.buffer = audioBuffer;
            source.loop = true;
            source.connect(context.destination);
            source.noteOn(0); //立即播放
        }
        function initSound(arrayBuffer) {
            context.decodeAudioData(arrayBuffer, function(buffer) { //解码成功时的回调函数
                audioBuffer = buffer;
                playSound();
            }, function(e) { //解码出错时的回调函数
                console.log('Error decoding file', e);
            });
        }
        function loadAudioFile(url) {
            var xhr = new XMLHttpRequest(); //通过XHR下载音频文件
            xhr.open('GET', url, true);
            xhr.responseType = 'arraybuffer';
            xhr.onload = function(e) { //下载完成
                console.log(e);
                initSound(this.response);
            };
            xhr.send();
        }
        loadAudioFile('./隔壁老樊 - 多想在平庸的生活拥抱你.flac');
    </script>
</body>
</html>
